VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsProcessEnum"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' clsProcessEnum: process enumeration interface
'
' Copyright (c) 2008 JaviteSoft ( http://www.javitesoft.com )

Private m_ProcessObj As Object
Private m_pIds As Collection
Private m_Index As Long
Private m_Count As Long

Friend Sub Init(ByVal ProcessObj As clsProcessController)

    Set m_ProcessObj = ProcessObj
    Set m_pIds = m_ProcessObj.BuildProcessIdCollection()
    m_Count = m_pIds.Count
    m_Index = 0
    
End Sub

Public Function Count() As Long
    Count = m_Count
End Function

Public Function NextProcess() As Boolean

    m_Index = m_Index + 1
    If m_Index <= Me.Count Then
        NextProcess = True
    Else
        NextProcess = False
    End If

End Function

Public Function GetProcess() As clsProcessController

    Dim thisProcess As New clsProcessController
    Set GetProcess = thisProcess.InitById(m_pIds(m_Index))
    
End Function

Public Sub EndEnum()
    m_ProcessObj.EndProcessEnum Me
End Sub


